<?php

// +-----------------------------------------------------------------------+
// |                             functions                                 |
// +-----------------------------------------------------------------------+

function counter_compare($a, $b)
{
  if ($a['counter'] == $b['counter'])
  {
    return id_compare($a, $b);
  }

  return ($a['counter'] < $b['counter']) ? +1 : -1;
}

function id_compare($a, $b)
{
  return ($a['id'] < $b['id']) ? -1 : 1;
}

// +-----------------------------------------------------------------------+
// |                           initialization                              |
// +-----------------------------------------------------------------------+

define('PHPWG_ROOT_PATH', '../../');
include_once(PHPWG_ROOT_PATH.'include/common.inc.php');

check_status(ACCESS_GUEST);

// +-----------------------------------------------------------------------+
// |                       page header and options                         |
// +-----------------------------------------------------------------------+

$title= l10n('Tags');
$page['body_id'] = 'theTagsPage';
include(PHPWG_ROOT_PATH.'include/page_header.php');

$template->set_filenames(array('tags'=>'tags.tpl'));
$template->assign_vars(
  array(
    'U_HOME' => make_index_url(),
    )
  );

// +-----------------------------------------------------------------------+
// |                        tag cloud construction                         |
// +-----------------------------------------------------------------------+

// find all tags available for the current user
$tags = get_available_tags();

$query = '
SELECT  t.id , tt.color
FROM ' . typetags_TABLE . ' AS tt
INNER JOIN ' . TAGS_TABLE . ' AS t
ON  t.id_typetags = tt.id
WHERE  t.id_typetags IS NOT NULL ;';

$result = pwg_query($query);
$tagsColor = array();
while ($row = mysql_fetch_assoc($result)) {
    $tagsColor += array($row['id'] => $row['color']);
}

// we want only the first most represented tags, so we sort them by counter
// and take the first tags
usort($tags, 'counter_compare');
$tags = array_slice($tags, 0, $conf['full_tag_cloud_items_number']);

// depending on its counter and the other tags counter, each tag has a level
$tags = add_level_to_tags($tags);

// we want tags diplayed in alphabetic order
usort($tags, 'name_compare');

// display sorted tags

foreach ($tags as $tag) {
    if (isset($tagsColor[$tag['id']])) {
       $tag['name'] = '<span style="color:' . $tagsColor[$tag['id']] . '">' . $tag['name'] . '</span>';
    }
    $template->assign_block_vars('tag',
        array('URL' => make_index_url(array('tags' => array($tag))),
            'NAME' => $tag['name'],
            'TITLE' => $tag['counter'],
            'CLASS' => 'tagLevel' . $tag['level']));
}

// +-----------------------------------------------------------------------+
// |                           html code display                           |
// +-----------------------------------------------------------------------+

$template->assign_block_vars('title',array());
$template->themeconf['icon_dir'] = '../../' . $template->themeconf['icon_dir'];
$template->parse('tags');
include(PHPWG_ROOT_PATH.'include/page_tail.php');

?>